from httplib import HTTPConnection
from cStringIO import StringIO
from ConfigParser import ConfigParser

config = ConfigParser()
config.read('config.ini')
protocol = config.get('remote', 'protocol')
domain = config.get('remote', 'domain')
port = config.get('remote', 'port')
path = config.get('remote', 'path')
username = config.get('remote', 'username')
password = config.get('remote', 'password')

# Clean up path
path = path.strip('/')
# Add auth info
path = "/%s/wurfl_xml_diff_tree_raw?__ac_name=%s&amp;__ac_password=%s" % (path, username, password)

conn = HTTPConnection(domain, port)
conn.request("GET", path)
try:
    r = conn.getresponse()
    if r.status != 200:
        raise "[sync_from_master_server] - %s, %s" % (r.status, r.reason)
    
    xml = r.read()        
finally:
    conn.close() 

from Zope2 import configure
configure(config.get('local', 'zopeconfig'))
import Zope2
app = Zope2.app()

plone = getattr(app, config.get('local', 'plone'))

# Switch user
from AccessControl.SecurityManagement import newSecurityManager, getSecurityManager
user = app.acl_users.getUser('admin').__of__(plone.acl_users)
newSecurityManager(None, user)

# Obtain mobile device
device = plone.unrestrictedTraverse(config.get('local', 'path_to_device')) 

# For some reason ATSChemaEditor cannot acquire the translate script, so monkey
# patch it.
def translate(msgid, mapping={}, default=None, domain='plone', target_language=None, escape_for_js=False):
    return ""
device.translate = translate

# Apply the diff
device.doUpdateDeviceTreeXML(wurflfile=StringIO(xml), 
    update_existing_devices=True)

# Remove translate
del device.translate

# Commit
get_transaction().commit()

print 'done'
